;CPU-AES-Bench CBC, 256-Bit-Passwortlnge, 03.10.2012
;Basiert auf Intels White Paper zur AES-Programmierung, dies sollte aber AMD-Fans nicht abschrecken!
;Flat Assembler 1.71.03
;Von flatassembler.net die aktuelle Windows-Version herunterladen, entpacken, bei include fr "...\Include\win64a.inc" den Pfad anpassen und los gehts!
;Messung der reinen Codier-/Decodier-CPU-Leistung
;Unbedingt mal anschauen: http://de.wikipedia.org/wiki/Electronic_Code_Book_Mode und http://de.wikipedia.org/wiki/Cipher_Block_Chaining_Mode
;Viel Spa wnscht Helle

format PE64 GUI 4.0

include 'C:\Codes\FAsm\Programm\Include\win64a.inc'   ;Pfad anpassen!

entry start

section '.text' code readable executable

  start:
    sub rsp,28h 	     ;nicht anfassen!

    invoke GetModuleHandle,0
    mov [hInstance],eax
    invoke RegisterClass,wc
    invoke CreateWindowEx,0,_class,_text1,WS_VISIBLE+WS_OVERLAPPEDWINDOW,100,150,1000,500,NULL,NULL,[hInstance],NULL	;100=X-Pos., 150=Y-Pos., 1000=Breite, 500=Hhe
    mov [hWnd],eax

;======================================================================================================================
    ;Anfang Test-Code, hier incl. Bildschirm-Ausgabe
;======================================================================================================================
    invoke CreateThread,NULL,0,thread_test,0,0,0 ;fr den Testcode wird ein eigener Thread erzeugt
    mov [hThread],eax

    jmp End_Test

;----------------------------------------------------------------------------------------------------------------------
proc thread_test
;---> CORE-ZUORDNUNG, selber testen!
    invoke SetThreadAffinityMask,[hThread],1b	 ;= Core0

    ;Test, ob die CPU berhaupt AES untersttzt
    mov eax,1h
    cpuid
    test ecx,2000000h
    jnz YesAES
    mov [Error],1	     ;kein AES
    ret 		     ;Tschss
YesAES:

    ;Speicher fr 3x 256MB reservieren
    mov [ValResMem],30002000h	  ;Gre reservierter Speicher, 3x256MB plus Hilfs-Speicher
    invoke VirtualAlloc,0,[ValResMem],MEM_COMMIT+MEM_RESERVE,PAGE_READWRITE    ;Speicher reservieren
    mov [AdrResMem],rax      ;Speicher-Anfangs-Adresse
    or rax,rax
    jnz YesMem		     ;angeforderter Speicher konnte bereitgestellt werden
    mov [Error],2	     ;nicht gengend Speicher
    ret 		     ;Tschss

YesMem:
    add rax,10000000h
    mov [Encrypt],rax
    add rax,10000000h
    mov [Decrypt],rax

    add rax,10000000h
    mov [Key_Schedule_Encrypt],rax     ;256 Byte
    add rax,100h
    mov [Key_Schedule_Decrypt],rax
    add rax,100h
    mov [UserKey],rax
    lea r8,[_Key1]
    movdqu xmm0,[r8]
    movdqa [rax],xmm0
    add rax,10h
    lea r8,[_Key2]
    movdqu xmm0,[r8]
    movdqa [rax],xmm0
    add rax,10h
    mov [InitialVector],rax
    lea r8,[_Init]
    movdqu xmm0,[r8]
    movdqa [rax],xmm0
    add rax,10h

    mov rax,[AdrResMem]
    add rax,30001000h
    mov [Plain],rax
    add rax,0f00h
    mov [Ausgabe],rax

    ;Ausgabe vorbereiten
    lea r8,[_text6]
    lea r9,[_text7]
    lea r10,[_text8]
    mov rcx,4
@@:
    movdqu xmm0,[r8]
    movdqu xmm1,[r9]
    movdqu xmm2,[r10]
    movdqu [rax],xmm0
    movdqu [rax+66],xmm1
    movdqu [rax+132],xmm2
    add r8,16
    add r9,16
    add r10,16
    add rax,16
    dec rcx
    jnz @b
    mov word[rax],0a0dh
    mov word[rax+66],0a0dh

    ;256MB Plaintext erzeugen (also das "Original")
    lea r8,[PlainText]
    movdqu xmm0,[r8]
    mov rcx,1000000h
    mov rdx,[AdrResMem]
@@:
    movdqu [rdx],xmm0
    add rdx,16
    dec rcx
    jnz @b

;fr Ivy Bridge oder andere CPU, die RDRAND kann
;    lea r8,[PlainText]
;    mov rax,[r8]
;    mov rcx,2000000h
;    mov rdx,[AdrResMem]
;@@:
;    rdrand rax
;    mov [rdx],rax
;    add rdx,8
;    dec rcx
;    jnz @b

;------------ E N C O D I N G -------------------
    ;Startzeit nehmen fr die Encodierung
    invoke QueryPerformanceCounter,Start

    call AES_256_Key_Expansion_Encrypt
    call AES_CBC_Encrypt
    ;Encodierung beendet, Endzeit nehmen
    invoke QueryPerformanceCounter,Ende
    invoke QueryPerformanceFrequency,Freq

    mov rax,[Ende]
    sub rax,[Start]
    mov rcx,1000	     ;dann ms
    mul rcx
    mov rcx,[Freq]
    xor rdx,rdx
    div rcx
    mov [TimeEnc],rax
    ;---
    mov rdi,[Ausgabe]	 ;Anfangs-Adresse String-Buffer
    add rdi,37
    call Hex2String

    mov rax,256000
    mov rcx,[TimeEnc]
    xor rdx,rdx
    div rcx
    mov rdi,[Ausgabe]	 ;Anfangs-Adresse String-Buffer
    add rdi,58
    call Hex2String
;------------------------------------------------
;------------ D E C O D I N G -------------------
    ;Startzeit nehmen fr die Decodierung
    invoke QueryPerformanceCounter,Start

    call AES_Key_Expansion_Decrypt
    call AES_CBC_Decrypt
    ;Decodierung beendet, Endzeit nehmen
    invoke QueryPerformanceCounter,Ende
    invoke QueryPerformanceFrequency,Freq

    mov rax,[Ende]
    sub rax,[Start]
    mov rcx,1000	     ;dann ms
    mul rcx
    mov rcx,[Freq]
    xor rdx,rdx
    div rcx
    mov [TimeDec],rax
    ;---
    mov rdi,[Ausgabe]	    ;Anfangs-Adresse String-Buffer
    add rdi,37+66
    call Hex2String

    mov rax,256000
    mov rcx,[TimeDec]
    xor rdx,rdx
    div rcx
    mov rdi,[Ausgabe]	 ;Anfangs-Adresse String-Buffer
    add rdi,57+66
    call Hex2String
;------------------------------------------------
;------------  B E R P R  F U N G  ------------
    mov rcx,2000000h
    mov r8,[AdrResMem]	     ;Original
    mov r9,r8
    add r9,20000000h
    mov rax,614ah	     ;"Ja"
;Test:
;mov byte[r9+123456],123
@@:
    mov rdx,[r8]	     ;oder z.B. PCMPESTRI
    cmp [r9],rdx
    jne Fehler
    add r8,8
    add r9,8
    dec rcx
    jnz @b
    jmp NoFehler
Fehler:
    mov rax,6e69654eh	     ;"Nein"
NoFehler:
    mov rdi,[Ausgabe]	     ;Anfangs-Adresse String-Buffer
    add rdi,37+66+65
    mov [rdi],rax
;------------------------------------------------

;Ausgabe 1024 Bytes Klartext
    mov rdi,[AdrResMem]      ;Anfangs-Adresse String-Buffer
    mov rsi,[Plain]
    xor r14,r14
    lea r8,[_Klar]	     ;Text
    mov rcx,5
 @@:
    movdqu xmm0,[r8]
    movdqu [rsi],xmm0
    add r8,16
    add rsi,16
    dec rcx
    jnz @b
    mov word[rsi],0a0dh      ;neue Zeile fr Ausgabe
    add rsi,2

    mov rcx,400h
 L0:
    mov al,[rdi]
    mov [rsi],al
    inc rdi
    inc rsi
    inc r14
    cmp r14,128 	     ;max.Zeilenlnge, oder runterzhlen
    jb @f
    mov word[rsi],0a0dh      ;neue Zeile fr Ausgabe
    add rsi,2
    xor r14,r14
 @@:
    dec rcx
    jnz L0

    mov word[rsi],0a0dh
    add rsi,2

;Ausgabe 1024 Bytes Encrypt
    mov rdi,[Encrypt]	     ;Anfangs-Adresse String-Buffer
    xor r14,r14
    lea r8,[_AES_V]	     ;Text
    mov rcx,7
 @@:
    movdqu xmm0,[r8]
    movdqu [rsi],xmm0
    add r8,16
    add rsi,16
    dec rcx
    jnz @b
    mov word[rsi],0a0dh      ;neue Zeile fr Ausgabe
    add rsi,2

    mov rcx,400h
 L00:
    mov al,[rdi]
    cmp al,0
    jne @f
    mov al,20h		       ;fr die Anzeige frisiert
 @@:
    mov [rsi],al
    inc rdi
    inc rsi
    inc r14
    cmp r14,128 	     ;max.Zeilenlnge, oder runterzhlen
    jb @f
    mov word[rsi],0a0dh      ;neue Zeile fr Ausgabe
    add rsi,2
    xor r14,r14
 @@:
    dec rcx
    jnz L00

    mov word[rsi],0a0dh
    add rsi,2

;Ausgabe 1024 Bytes Decrypt
    mov rdi,[Decrypt]	     ;Anfangs-Adresse String-Buffer
    xor r14,r14
    lea r8,[_AES_D]	     ;Text
    mov rcx,5
 @@:
    movdqu xmm0,[r8]
    movdqu [rsi],xmm0
    add r8,16
    add rsi,16
    dec rcx
    jnz @b
    mov word[rsi],0a0dh      ;neue Zeile fr Ausgabe
    add rsi,2

    mov rcx,400h
 L000:
    mov al,[rdi]
    cmp al,0
    jne @f
    mov al,20h		       ;fr die Anzeige frisiert
 @@:
    mov [rsi],al
    inc rdi
    inc rsi
    inc r14
    cmp r14,128 	     ;max.Zeilenlnge, oder runterzhlen
    jb @f
    mov word[rsi],0a0dh      ;neue Zeile fr Ausgabe
    add rsi,2
    xor r14,r14
 @@:
    dec rcx
    jnz L000

    ;Zero-Byte setzen fr Ausgabe-String
    mov byte[rsi],0

    ;Bildschirm-Ausgabe
    invoke SendMessage,[edithwnd],WM_SETTEXT,0,[Plain]	   ;Ausgabe je 1024 Bytes Plain-, Encoding- und Decoding-Daten
    invoke  MessageBoxA,[hWnd],[Ausgabe],_text2,MB_OK

   ret


;papapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapa
 ;--------------------- Key_Expansion_Encrypt AES_256 ---------------------
 proc Make_Roundkey_AES_256_a	  ;evtl. als Macros
   pshufd xmm2,xmm2,255
   movdqa xmm4,xmm1
   pslldq xmm4,4
   pxor xmm1,xmm4
   pslldq xmm4,4
   pxor xmm1,xmm4
   pslldq xmm4,4
   pxor xmm1,xmm4
   pxor xmm1,xmm2
   add r11,16
   movdqa [r11],xmm1

   ret
 endp
;pepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepe

;papapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapa
 proc Make_Roundkey_AES_256_b
   pshufd xmm2,xmm2,170
   movdqa xmm4,xmm3
   pslldq xmm4,4
   pxor xmm3,xmm4
   pslldq xmm4,4
   pxor xmm3,xmm4
   pslldq xmm4,4
   pxor xmm3,xmm4
   pxor xmm3,xmm2
   add r11,16
   movdqa [r11],xmm3

   ret
 endp
;pepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepe

;papapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapa
 proc AES_256_Key_Expansion_Encrypt
   mov r10,[UserKey]	     ;Pointer auf UserKey (Passwort)
   mov r11,[Key_Schedule_Encrypt] ;Pointer auf Key_Schedule_Encrypt
   movdqu xmm1,[r10]
   movdqu xmm3,[r10+16]
   movdqa [r11],xmm1
   add r11,16
   movdqa [r11],xmm3
   aeskeygenassist xmm2,xmm3,1
   call Make_Roundkey_AES_256_a
   aeskeygenassist xmm2,xmm1,0
   call Make_Roundkey_AES_256_b
   aeskeygenassist xmm2,xmm3,2
   call Make_Roundkey_AES_256_a
   aeskeygenassist xmm2,xmm1,0
   call Make_Roundkey_AES_256_b
   aeskeygenassist xmm2,xmm3,4
   call Make_Roundkey_AES_256_a
   aeskeygenassist xmm2,xmm1,0
   call Make_Roundkey_AES_256_b
   aeskeygenassist xmm2,xmm3,8
   call Make_Roundkey_AES_256_a
   aeskeygenassist xmm2,xmm1,0
   call Make_Roundkey_AES_256_b
   aeskeygenassist xmm2,xmm3,16
   call Make_Roundkey_AES_256_a
   aeskeygenassist xmm2,xmm1,0
   call Make_Roundkey_AES_256_b
   aeskeygenassist xmm2,xmm3,32
   call Make_Roundkey_AES_256_a
   aeskeygenassist xmm2,xmm1,0
   call Make_Roundkey_AES_256_b
   aeskeygenassist xmm2,xmm3,64
   call Make_Roundkey_AES_256_a

   ret
 endp
;-------------------------------------------------------------------------
;pepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepe

;papapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapa
;-------------------------------------------------------------------------
 proc AES_CBC_Encrypt
   mov r10,[AdrResMem]	;Pointer auf Speicherort Original-Daten
   mov r11,[Encrypt]	;Pointer auf Speicherort encodierte Daten
   mov rdx,[InitialVector]   ;Pointer auf InitialVector
   mov rcx,10000000h	;256MB, Gre der encodierten Daten
   mov r8,[Key_Schedule_Encrypt]  ;Pointer auf Key_Schedule_Encrypt
   mov rax,rcx
   shr rcx,4
   shl rax,60
   jz E_NO_PARTS_CBC
   add rcx,1
 E_NO_PARTS_CBC:
   sub r11,16
   movdqu xmm1,[rdx]
 E_LOOP_CBC:
   pxor xmm1,[r10]
   pxor xmm1,[r8]
   add r10,16
   add r11,16
   aesenc xmm1,[r8+16]
   aesenc xmm1,[r8+32]
   aesenc xmm1,[r8+48]
   aesenc xmm1,[r8+64]
   aesenc xmm1,[r8+80]
   aesenc xmm1,[r8+96]
   aesenc xmm1,[r8+112]
   aesenc xmm1,[r8+128]
   aesenc xmm1,[r8+144]
   movdqa xmm2,[r8+160]
   aesenc xmm1,[r8+160]
   aesenc xmm1,[r8+176]
   movdqa xmm2,[r8+192]
   aesenc xmm1,[r8+192]
   aesenc xmm1,[r8+208]
   movdqa xmm2,[r8+224]
   dec rcx
   aesenclast xmm1,xmm2
   movdqu [r11],xmm1
   jnz E_LOOP_CBC

  ret
 endp
;-------------------------------------------------------------------------
;pepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepe

;papapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapa
;-------------------------------------------------------------------------
 proc AES_Key_Expansion_Decrypt
   mov r10,[Key_Schedule_Encrypt] ;Pointer auf Key_Schedule_Encrypt
   mov r11,[Key_Schedule_Decrypt] ;Pointer auf Key_Schedule_Decrypt
   mov rax,14		     ;Rundenanzahl, fr 256-Bit-Keywort=14
   shl rax,4
   mov rcx,rax
   add rcx,r10
   movdqa xmm0,[rcx]
   movdqa [r11],xmm0
   sub rcx,208
   aesimc xmm1,[rcx+192]
   aesimc xmm2,[rcx+176]
   aesimc xmm3,[rcx+160]
   aesimc xmm4,[rcx+144]
   movdqa [r11+16],xmm1
   movdqa [r11+32],xmm2
   movdqa [r11+48],xmm3
   movdqa [r11+64],xmm4
   aesimc xmm5,[rcx+128]
   aesimc xmm6,[rcx+112]
   aesimc xmm7,[rcx+96]
   aesimc xmm8,[rcx+80]
   movdqa [r11+80],xmm5
   movdqa [r11+96],xmm6
   movdqa [r11+112],xmm7
   movdqa [r11+128],xmm8
   aesimc xmm9,[rcx+64]
   movdqa [r11+144],xmm9
   aesimc xmm0,[rcx+48]
   aesimc xmm1,[rcx+32]
   movdqa [r11+160],xmm0
   movdqa [r11+176],xmm1
   aesimc xmm0,[rcx+16]
   aesimc xmm1,[rcx]
   movdqa [r11+192],xmm0
   movdqa [r11+208],xmm1
 END_DEC:
   movdqa xmm0,[r10]
   add r11,rax
   movdqa [r11],xmm0

  ret
 endp
;-------------------------------------------------------------------------
;pepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepe

;papapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapa
;-------------------------------------------------------------------------
 proc AES_CBC_Decrypt
   mov r10,[Encrypt]	     ;Pointer auf Speicherort encodierte Daten
   mov r11,[Decrypt]	     ;Pointer auf Speicherort decodierte Daten
   mov rdx,[InitialVector]   ;Pointer auf InitialVector
   mov rcx,10000000h	     ;256MB, Gre der encodierten Daten
   mov r8,[Key_Schedule_Decrypt]  ;Pointer auf Key_Schedule_Decrypt
   mov rax,rcx
   shr rcx,4
   shl rax,60
   jz D_NO_PARTS_4_CBC
   add rcx,1
 D_NO_PARTS_4_CBC:
   mov rax,rcx
   shl rax,62
   shr rax,62
   shr rcx,2
   movdqu xmm5,[rdx]
   jz D_REMAINDER_4_CBC
   sub r11,64
 D_LOOP_4_CBC:
   movdqu xmm1,[r10]
   movdqu xmm2,[r10+16]
   movdqu xmm3,[r10+32]
   movdqu xmm4,[r10+48]
   movdqa xmm6,xmm1
   movdqa xmm7,xmm2
   movdqa xmm8,xmm3
   movdqa xmm15,xmm4
   movdqa xmm9,[r8]
   movdqa xmm10,[r8+16]
   movdqa xmm11,[r8+32]
   movdqa xmm12,[r8+48]
   pxor xmm1,xmm9
   pxor xmm2,xmm9
   pxor xmm3,xmm9
   pxor xmm4,xmm9
   aesdec xmm1,xmm10
   aesdec xmm2,xmm10
   aesdec xmm3,xmm10
   aesdec xmm4,xmm10
   aesdec xmm1,xmm11
   aesdec xmm2,xmm11
   aesdec xmm3,xmm11
   aesdec xmm4,xmm11
   aesdec xmm1,xmm12
   aesdec xmm2,xmm12
   aesdec xmm3,xmm12
   aesdec xmm4,xmm12
   movdqa xmm9,[r8+64]
   movdqa xmm10,[r8+80]
   movdqa xmm11,[r8+96]
   movdqa xmm12,[r8+112]
   aesdec xmm1,xmm9
   aesdec xmm2,xmm9
   aesdec xmm3,xmm9
   aesdec xmm4,xmm9
   aesdec xmm1,xmm10
   aesdec xmm2,xmm10
   aesdec xmm3,xmm10
   aesdec xmm4,xmm10
   aesdec xmm1,xmm11
   aesdec xmm2,xmm11
   aesdec xmm3,xmm11
   aesdec xmm4,xmm11
   aesdec xmm1,xmm12
   aesdec xmm2,xmm12
   aesdec xmm3,xmm12
   aesdec xmm4,xmm12
   movdqa xmm9,[r8+128]
   movdqa xmm10,[r8+144]
   movdqa xmm11,[r8+160]
   aesdec xmm1,xmm9
   aesdec xmm2,xmm9
   aesdec xmm3,xmm9
   aesdec xmm4,xmm9
   aesdec xmm1,xmm10
   aesdec xmm2,xmm10
   aesdec xmm3,xmm10
   aesdec xmm4,xmm10
   movdqa xmm9,[r8+160]
   movdqa xmm10,[r8+176]
   movdqa xmm11,[r8+192]
   aesdec xmm1,xmm9
   aesdec xmm2,xmm9
   aesdec xmm3,xmm9
   aesdec xmm4,xmm9
   aesdec xmm1,xmm10
   aesdec xmm2,xmm10
   aesdec xmm3,xmm10
   aesdec xmm4,xmm10
   movdqa xmm9,[r8+192]
   movdqa xmm10,[r8+208]
   movdqa xmm11,[r8+224]
   aesdec xmm1,xmm9
   aesdec xmm2,xmm9
   aesdec xmm3,xmm9
   aesdec xmm4,xmm9
   aesdec xmm1,xmm10
   aesdec xmm2,xmm10
   aesdec xmm3,xmm10
   aesdec xmm4,xmm10
   add r10,64
   add r11,64
   aesdeclast xmm1,xmm11
   aesdeclast xmm2,xmm11
   aesdeclast xmm3,xmm11
   aesdeclast xmm4,xmm11
   pxor xmm1,xmm5
   pxor xmm2,xmm6
   pxor xmm3,xmm7
   pxor xmm4,xmm8
   movdqu [r11],xmm1
   movdqu [r11+16],xmm2
   movdqu [r11+32],xmm3
   movdqu [r11+48],xmm4
   movdqa xmm5,xmm15
   dec rcx
   jnz D_LOOP_4_CBC
   add r11,64
 D_REMAINDER_4_CBC:
   cmp rax,0
   je D_END_4_CBC
 D_LOOP_4_2_CBC:
   movdqu xmm1,[r10]
   movdqa xmm15,xmm1
   add r10,16
   pxor xmm1,[r8]
   movdqu xmm2,[r8+160]
   aesdec xmm1,[r8+16]
   aesdec xmm1,[r8+32]
   aesdec xmm1,[r8+48]
   aesdec xmm1,[r8+64]
   aesdec xmm1,[r8+80]
   aesdec xmm1,[r8+96]
   aesdec xmm1,[r8+112]
   aesdec xmm1,[r8+128]
   aesdec xmm1,[r8+144]
   movdqu xmm2,[r8+192]
   aesdec xmm1,[r8+160]
   aesdec xmm1,[r8+176]
   movdqu xmm2,[r8+224]
   aesdec xmm1,[r8+192]
   aesdec xmm1,[r8+208]
   aesdeclast xmm1,xmm2
   pxor xmm1,xmm5
   movdqa xmm5,xmm15
   movdqu [r11],xmm1
   add r11,16
   dec rax
   jnz D_LOOP_4_2_CBC
 D_END_4_CBC:

  ret
 endp
;-------------------------------------------------------------------------
;pepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepe

;papapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapapa
 proc Hex2String
    ;Konvertierung Hex in Ausgabe-String, hier eigene Routine
    xor r14,r14 	     ;Zeichenzhler fr Zeilenlnge
    xor rbx,rbx 	     ;bl=Ziffer
    xor r12,r12 	     ;Pointer in Dezi-Tabelle
    xor r10,r10 	     ;Merker fhrende Null(en)
    mov r9,[Dezi]	     ;hchster Wert aus Dezi-Tabelle
    mov rcx,rax 	     ;rax=Hex-Wert

  Konv1:
    sub rax,r9
    jc @f
    inc bl
    mov rcx,rax
    jmp Konv1
  @@:
    cmp bl,r10b 	     ;fhrende Nullen ausblenden
    je @f
    mov r10b,0ffh	     ;naja...
    or bl,30h		     ;Dezimal-Ziffer schreiben
    mov [rdi],bl
    inc r14		     ;Zeichenzhler
    inc rdi		     ;Pointer in String-Buffer
  @@:
    add r12,8		     ;nchster Wert aus Dezi-Tabelle
    mov r9,[Dezi+r12]
    or r9,r9
    jz @f		     ;Ende erreicht
    mov rax,rcx
    xor rbx,rbx
    jmp Konv1
  @@:
    or cl,30h		     ;letzte Ziffer
    mov [rdi],cl

    ret

  Align 16
  Dezi dq 10000000000000000000	  ;fr Konvertierung Hex in Dezimal-String fr Ausgabe
       dq  1000000000000000000
       dq   100000000000000000
       dq    10000000000000000
       dq     1000000000000000
       dq      100000000000000
       dq	10000000000000
       dq	 1000000000000
       dq	  100000000000
       dq	   10000000000
       dq	    1000000000
       dq	     100000000
       dq	      10000000
       dq	       1000000
       dq		100000
       dq		 10000
       dq		  1000
       dq		   100
       dq		    10
       dq		     0
 endp
;pepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepepe

endp

End_Test:
;======================================================================================================================
    ;Ende Test-Code incl. Bildschirm-Ausgabe
;======================================================================================================================

;--------------------------------------------------------------------------
  msg_loop:
    cmp [Error],0
    jnz end_loop	       ;es ist ein Fehler aufgetreten
    invoke GetMessage,msg,NULL,0,0
    cmp eax,1
    jb end_loop
    jne msg_loop
    invoke TranslateMessage,msg
    invoke DispatchMessage,msg
    jmp msg_loop
  end_loop:

    cmp [Error],0
    je NoError
    cmp [Error],1
    jne @f
    invoke  MessageBoxA,[hWnd],_text4,_text3,MB_OK + MB_ICONWARNING
    jmp NoError
@@:
    cmp [Error],2
    jne @f
    invoke  MessageBoxA,[hWnd],_text5,_text3,MB_OK + MB_ICONWARNING
    jmp NoError
@@:			     ;falls noch was anfllt

  NoError:
    invoke ExitProcess,[msg.wParam]

proc WindowProc hwnd,wmsg,wparam,lparam
    mov [hwnd],rcx
    mov [wmsg],rdx
    mov [wparam],r8
    mov [lparam],r9

    cmp [wmsg],WM_CREATE
    je .wmcreate

    cmp [wmsg],WM_DESTROY
    je .wmdestroy
  .defwndproc:
    invoke DefWindowProc,[hwnd],[wmsg],[wparam],[lparam]
    jmp .finish

  .wmcreate:
    invoke GetClientRect,[hwnd],client
    invoke CreateWindowEx,WS_EX_CLIENTEDGE,_edit,0,WS_VISIBLE+WS_CHILD+WS_HSCROLL+WS_VSCROLL+ES_AUTOHSCROLL+ES_AUTOVSCROLL+ES_MULTILINE,[client.left],[client.top],[client.right],[client.bottom],[hwnd],0,[hInstance],NULL
    mov [edithwnd],eax
    invoke CreateFont,14,0,0,0,0,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_RASTER_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,FIXED_PITCH+FF_DONTCARE,NULL
    mov [editfont],eax
    invoke SendMessage,[edithwnd],WM_SETFONT,eax,FALSE
    jmp .finish

  .wmdestroy:
    invoke DeleteObject,[editfont]
    invoke PostQuitMessage,0

  .finish:
    ret
endp

;----------------------------------------------------------------------------------------------------------------------
section '.data' data readable writeable

;======================================================================================================================
    ;Anfang Test-Daten
;======================================================================================================================
  ValResMem		dq ?		    ;reservierter Speicher
  AdrResMem		dq ?		    ;Pointer fr 256MB (Anfang)
  Encrypt		dq ?		    ;Pointer fr 256MB
  Decrypt		dq ?		    ;Pointer fr 256MB
  Plain 		dq ?		    ;Pointer fr Anzeige
  Ausgabe		dq ?		    ;Pointer
  TimeEnc		dq ?
  TimeDec		dq ?
  PlainText		dq 7478655472616c4Bh
  PlainText1		dq 4847464544434241h
  Key_Schedule_Encrypt	dq ?		    ;Pointer
  Key_Schedule_Decrypt	dq ?		    ;Pointer
  UserKey		dq ?		    ;Pointer
  InitialVector 	dq ?		    ;Pointer

  _text1 TCHAR 'AES-Bench CBC, 256-Bit-Schlssellnge, Daten-Gre 256 MB',0
  _text2 TCHAR 'Auswertung AES-Bench CBC, 256-Bit-Schlssellnge',0
  _text3 TCHAR 'F E H L E R !',0
  _text4 TCHAR 'Diese CPU bietet keine Hardware-Untersttzung von AES!',0
  _text5 TCHAR 'Der angeforderte Speicher konnte nicht bereitgestellt werden!',0
  _text6 TCHAR 'Zeit in ms fr 256 MB Encoding :           ->  MB/s :           ',0
  _text7 TCHAR 'Zeit in ms fr 256 MB Decoding :           ->  MB/s :           ',0
  _text8 TCHAR 'bereinstimmung Plain-Decoding :                                ',0
  _Key1 TCHAR  'Keyword Part One',0    ;frei whlbar, jeweils 16 Bytes
  _Key2 TCHAR  'Keyword Part Two',0
  _Init TCHAR  'VectorforInitial',0
  _Klar TCHAR  'Dies sind die ersten 1024 Bytes der Ausgangs-Daten (Plain-Text) :               ',0
  _AES_V TCHAR 'Dies sind die ersten 1024 Bytes der AES-verschlsselten Daten (fr Anzeige Null durch Leerzeichen ersetzt) :    ',0
  _AES_D TCHAR 'Dies sind die ersten 1024 Bytes der wieder entschlsselten Daten :              ',0

;======================================================================================================================
    ;Ende Test-Daten
;======================================================================================================================

  wc WNDCLASS 0,WindowProc,0,0,NULL,NULL,NULL,COLOR_BTNFACE+1,NULL,_class

Align 8 			  ;muss sein!
  Error     dq 0
  Freq	    dq ?		  ;fr Zeit-Messung
  Start     dq ?
  Ende	    dq ?
  hWnd	    dd ?
  hInstance dd ?
  hThread   dd ?
  edithwnd  dd ?
  editfont  dd ?

  msg MSG
  client RECT

  _class TCHAR 'Ausgabe',0
  _edit TCHAR 'edit',0

;----------------------------------------------------------------------------------------------------------------------
section '.idata' import data readable writeable

  library kernel,'KERNEL32.DLL',\
	  user,'USER32.DLL',\
	  gdi,'GDI32.DLL'

   import kernel,\
	  GetModuleHandle,'GetModuleHandleA',\
	  ExitProcess,'ExitProcess',\
	  SetThreadAffinityMask,'SetThreadAffinityMask',\
	  CreateThread,'CreateThread',\
	  VirtualAlloc,'VirtualAlloc',\
	  QueryPerformanceFrequency,'QueryPerformanceFrequency',\
	  QueryPerformanceCounter,'QueryPerformanceCounter'

   import user,\
	  RegisterClass,'RegisterClassA',\
	  CreateWindowEx,'CreateWindowExA',\
	  DefWindowProc,'DefWindowProcA',\
	  TranslateMessage,'TranslateMessage',\
	  DispatchMessage,'DispatchMessageA',\
	  GetClientRect,'GetClientRect',\
	  SendMessage,'SendMessageA',\
	  PostQuitMessage,'PostQuitMessage',\
	  GetMessage,'GetMessageA',\
	  SetWindowText,'SetWindowTextA',\
	  MessageBoxA,'MessageBoxA'

   import gdi,\
	  CreateFont,'CreateFontA',\
	  DeleteObject,'DeleteObject'

;Ende